from decimal import Decimal, ROUND_FLOOR
import decimal 
from typing import List

from immutablelist.AbstractImmutableList import AbstractImmutableList
from immutablelist.ImmutableList import ImmutableList


class Range(AbstractImmutableList[Decimal]):
    def __init__(self, low:Decimal, high: Decimal, step:Decimal):
        self._low=low
        self._high=high
        self._step=step
        
    def getLow(self):
        return self._low
    
    def getHigh(self):
        return self._high
    
    def getStep(self):
        return self._step
    
    def get(self, index:int)-> Decimal:
        return self._low+ self._step  * index
    
    def size(self) -> Decimal:
        if self._low > self._high:
            return Decimal(0)
        return  (( self._high - self._low )/self._step) \
            .quantize(Decimal('1'), rounding=ROUND_FLOOR) + Decimal('1')
    
    def __eq__(self, other)->bool:
        return isinstance(other, self.__class__) and \
             self._low == other._low and \
             self._high == other._high and\
             self._step == other._step

    def __str__(self):
        return "Range["+self._low+","+self._high+","+self._step+"]"