from decimal import Decimal
import unittest

from pyson.ObjectMapper import ObjectMapper

from geniusweb.issuevalue.NumberValue import NumberValue
from geniusweb.issuevalue.NumberValueSet import NumberValueSet
from geniusweb.issuevalue.ValueSet import ValueSet
from immutablelist.Range import Range


class NumberValueSetTest(unittest.TestCase):
    pyson=ObjectMapper()
    val = NumberValueSet(Range(Decimal('12.2'), Decimal('12.6'), Decimal('0.3')))
    valjson = {"range":{"low":12.2,"high":12.6,"step":0.3}}

    def testSerialize(self):
        print(str(self.pyson.toJson(self.val)))
        self.assertEqual(self.valjson, self.pyson.toJson(self.val))
        
    def testDeserialize(self):
        self.assertEqual(self.val, self.pyson.parse(self.valjson, ValueSet))
        
    def testIterator(self):
        self.assertTrue(NumberValue(Decimal('12.2')) in self.val)